import axios from "axios";

let token;
const TOKEN_KEY = "token";

const generateUUID = () => {
  let d = new Date().getTime(),
    d2 = (performance && performance.now && performance.now() * 1000) || 0;
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, (c) => {
    let r = Math.random() * 16;
    if (d > 0) {
      r = (d + r) % 16 | 0;
      d = Math.floor(d / 16);
    } else {
      r = (d2 + r) % 16 | 0;
      d2 = Math.floor(d2 / 16);
    }
    return (c == "x" ? r : (r & 0x7) | 0x8).toString(16);
  });
};

export const getToken = () => {
  if (token) {
    return token;
  }
  if (window) {
    if (!window.sessionStorage.getItem(TOKEN_KEY)) {
      window.sessionStorage.setItem(TOKEN_KEY, generateUUID());
    }
    token = window.sessionStorage.getItem(TOKEN_KEY);
  }
  return token;
};

export const applyDiff = (state, diff) => {
  for (const substate in diff) {
    let s = state;
    const path = substate.split(".").slice(1);
    while (path.length > 0) {
      s = s[path.shift()];
    }
    for (const key in diff[substate]) {
      s[key] = diff[substate][key];
    }
  }
  return state;
};

export const applyEvent = async (state, event, endpoint) => {
  event.token = getToken();
  const diff = (await axios.post(endpoint, event)).data;
  return applyDiff(state, diff);
};

export const updateState = async (state, setState, endpoint) => {
  if (state.processing || state.events.length == 0) {
    return;
  }
  setState({ ...state, processing: true });
  await applyEvent(state, state.events.pop(), endpoint);
  setState({
    ...state,
    events: state.events,
    processing: false,
  });
};
