"""Import all the components."""

from pynecone import utils
from pynecone.var import Var

from .component import Component
from .datadisplay import *
from .disclosure import *
from .feedback import *
from .forms import *
from .graphing import *
from .layout import *
from .media import *
from .navigation import *
from .overlay import *
from .typography import *

# Add the convenience methods for all the components.
locals().update(
    {
        utils.to_snake_case(name): value.create
        for name, value in locals().items()
        if isinstance(value, type) and issubclass(value, Component)
    }
)

# Add responsive styles shortcuts.
def mobile_only(*args, **kwargs):
    return box(*args, **kwargs, display=["block", "none", "none", "none"])


def tablet_only(*args, **kwargs):
    return box(*args, **kwargs, display=["none", "block", "block", "none"])


def desktop_only(*args, **kwargs):
    return box(*args, **kwargs, display=["none", "none", "none", "block"])


def tablet_and_desktop(*args, **kwargs):
    return box(*args, **kwargs, display=["none", "block", "block", "block"])


def mobile_and_tablet(*args, **kwargs):
    return box(*args, **kwargs, display=["block", "block", "block", "none"])
