"""Table components."""

from typing import List, Any

from pynecone.components.component import Component
from pynecone.components.tags import Tag
from pynecone.var import Var


class Gridjs(Component):
    """A component that wraps a nivo bar component."""

    library = "gridjs-react"


class DataTable(Gridjs):
    """A data table component."""

    tag = "Grid"

    df: Any

    data: Var[List]

    columns: Var[List]

    search: Var[bool]

    sort: Var[bool]

    resizable: Var[bool]

    pagination: Var[bool]

    def _get_custom_code(self) -> str:
        return """
import "gridjs/dist/theme/mermaid.css";
"""

    def _render(self) -> Tag:
        if self.df is not None:
            self.data = Var.create(list(self.df.values.tolist()))  # type: ignore
            self.columns = Var.create(list(self.df.columns.values.tolist()))  # type: ignore
            self.df = None

        return super()._render()
